--***************************************************************
mogliBase20.newClass( "GearboxHud" )
--***************************************************************

function GearboxHud:draw()
	if not GearboxHud.overlayG then -- aspect ratio independent code by Decker MMIV. Thx :)
        --DEFINE BLOCK
		local iconWidth = math.floor(0.0095 * g_screenWidth) / g_screenWidth;
        local iconHeight = iconWidth * g_screenAspectRatio;
		local backW = math.floor(0.0114 * g_screenWidth) / g_screenWidth;
        local xAdjust = iconWidth * 0.25
        local yAdjust = iconHeight * 0.25
    
        local x,y = g_currentMission.speedHud.x,g_currentMission.speedHud.y;
        local w,h = g_currentMission.speedHud.width,g_currentMission.speedHud.height;
        --local xIndent,yIndent = 0,0
    
        --local halfTextW = getTextWidth(g_currentMission.speedUnitTextSize, "100%") / 2
		
		if self.backgroundOverlayId == nil then
			self.backgroundOverlayId = createImageOverlay( "dataS2/menu/blank.png" )
			setOverlayColor( self.backgroundOverlayId, 0,0,0, 0.4 )
		end
		renderOverlay( self.backgroundOverlayId, x-0.0058, y+h+0.01, 1.0058-x, iconHeight*2 );
				
		if self.mrGbMGetIsOn ~= nil and self:mrGbMGetIsOn() then
			self.overlayG = Overlay:new("overlayG", (GearboxHud.baseDirectory.."Scripts/HUD/G.dds"), x,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayE = Overlay:new("overlayE", (GearboxHud.baseDirectory.."Scripts/HUD/E.dds"), x+1.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayA = Overlay:new("overlayA", (GearboxHud.baseDirectory.."Scripts/HUD/A.dds"), x+2.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayR = Overlay:new("overlayR", (GearboxHud.baseDirectory.."Scripts/HUD/R.dds"), x+3.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayB = Overlay:new("overlayB", (GearboxHud.baseDirectory.."Scripts/HUD/B.dds"), x+4.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayO = Overlay:new("overlayO", (GearboxHud.baseDirectory.."Scripts/HUD/O.dds"), x+5.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayX = Overlay:new("overlayX", (GearboxHud.baseDirectory.."Scripts/HUD/X.dds"), x+6.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			
			--if self.driveControl.handBrake.isActive and (self.vehicle.driveControl ~= nil) then
			if self.mrGbML.lastDCHandBrake then
				self.overlayN_P   = Overlay:new("overlayN_P",   (GearboxHud.baseDirectory.."Scripts/HUD/P.dds"), x+12.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			elseif self.mrGbMS.NeutralActive then
				self.overlayN_P   = Overlay:new("overlayN_P",   (GearboxHud.baseDirectory.."Scripts/HUD/N.dds"), x+12.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			else
				self.overlayN_P   = Overlay:new("overlayN_P",   (GearboxHud.baseDirectory.."Scripts/HUD/NIL.dds"), x+12.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			end
			if	self.mrGbMS.ReverseActive then
				self.overlayGEAR   = Overlay:new("overlayGEAR",   (GearboxHud.baseDirectory.."Scripts/HUD/"..string.sub(self.mrGbMS.Gears[self.mrGbMS.CurrentGear].name,2)..".dds"),  x+16.5*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			else	
				self.overlayGEAR   = Overlay:new("overlayGEAR",   (GearboxHud.baseDirectory.."Scripts/HUD/"..self.mrGbMS.Gears[self.mrGbMS.CurrentGear].name..".dds"), x+16.5*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			end
			
			if self.mrGbMS.Automatic then
				self.overlayA_M   = Overlay:new("overlayA_M",   (GearboxHud.baseDirectory.."Scripts/HUD/A.dds"),  x+10.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			else
				self.overlayA_M   = Overlay:new("overlayA_M",   (GearboxHud.baseDirectory.."Scripts/HUD/M.dds"),  x+10.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			end
			
			if self.mrGbMS.CurrentRange == 1 then			
				self.overlayL_H   = Overlay:new("overlayL_H",   (GearboxHud.baseDirectory.."Scripts/HUD/LOW.dds"), x+15.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			elseif self.mrGbMS.CurrentRange == 2 then
				self.overlayL_H   = Overlay:new("overlayL_H",   (GearboxHud.baseDirectory.."Scripts/HUD/HI.dds"), x+15.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			end
			if	self.mrGbMS.ReverseActive then
				self.overlayDIR   = Overlay:new("overlayDIR",   (GearboxHud.baseDirectory.."Scripts/HUD/R.dds"),  x+13.5*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			else
				self.overlayDIR   = Overlay:new("overlayDIR",   (GearboxHud.baseDirectory.."Scripts/HUD/D.dds"),  x+13.5*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			end	
			--DEFINE END
			--RENDER BLOCK
			self.overlayG:render();	
			self.overlayE:render();	
			self.overlayA:render();	
			self.overlayR:render();	
			self.overlayB:render();	
			self.overlayO:render();	
			self.overlayX:render();	
			self.overlayN_P:render();
			self.overlayGEAR:render();
			self.overlayA_M:render();
			self.overlayDIR:render();	
			self.overlayL_H:render();
			--RENDER END
			--DELETE OVERLAY
			self.overlayG:delete();
			self.overlayE:delete();
			self.overlayA:delete();
			self.overlayR:delete();
			self.overlayB:delete();
			self.overlayO:delete();
			self.overlayX:delete();
			self.overlayN_P:delete();
			self.overlayGEAR:delete();
			self.overlayA_M:delete();
			self.overlayDIR:delete();	
			self.overlayL_H:delete();
			--DELETE END
		else
			self.overlayG_ = Overlay:new("overlayG_", (GearboxHud.baseDirectory.."Scripts/HUD/G_.dds"), x,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayE_ = Overlay:new("overlayE", (GearboxHud.baseDirectory.."Scripts/HUD/E_.dds"), x+1.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayA_ = Overlay:new("overlayA", (GearboxHud.baseDirectory.."Scripts/HUD/A_.dds"), x+2.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayR_ = Overlay:new("overlayR", (GearboxHud.baseDirectory.."Scripts/HUD/R_.dds"), x+3.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayB_ = Overlay:new("overlayB", (GearboxHud.baseDirectory.."Scripts/HUD/B_.dds"), x+4.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayO_ = Overlay:new("overlayO", (GearboxHud.baseDirectory.."Scripts/HUD/O_.dds"), x+5.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			self.overlayX_ = Overlay:new("overlayX", (GearboxHud.baseDirectory.."Scripts/HUD/X_.dds"), x+6.0*iconWidth,y+h+0.01+0.5*iconHeight, iconWidth,iconHeight);
			--
			self.overlayG_:render();
			self.overlayE_:render();	
			self.overlayA_:render();	
			self.overlayR_:render();	
			self.overlayB_:render();	
			self.overlayO_:render();	
			self.overlayX_:render();
			--delete?
			self.overlayG_:delete();
			self.overlayE_:delete();
			self.overlayA_:delete();
			self.overlayR_:delete();
			self.overlayB_:delete();
			self.overlayO_:delete();
			self.overlayX_:delete();
		end
	end
end;